# NASA Astronaut Comparison and Statistics

 ## Description

 <img src=https://cloudbox.ku.ac.th/index.php/s/kGM2NLkn47cdRRN/preview width=500 height=430>

 The NASA Astronaut Comparison and Statistics is an application for displaying brief 
 information about NASA astronauts, the descriptive statistics of each group and the data visualization. The data visualization
 is a map and graphs which the interface features bar chart, histogram, box plot, heatmap and pie chart. Furthermore,
users are also freely to select the dropdown menu that correspond to each section of the application include
selecting the astronauts to compare their career statistics.

For more details, here is the provided link to the demonstration video

https://youtu.be/6-79jKQ1mdk

## Data Sources
The data source, which is included in my project, is the comma-separated values file called astronaut.csv. This file is
the collection of NASA Astronauts data from the first group selection to the 20th group selection. 
Data source reference: https://github.com/aploetz/packt/blob/master/astronauts.csv
 
## Running the Application
The users must install every library that are provided in the requirements.txt and the interface will be visible
after running the main.py file.
 
## Design

<img src=https://cloudbox.ku.ac.th/index.php/s/DBeQXeLzNq9MMKF/preview width=420 height=315 /> <img src=https://cloudbox.ku.ac.th/index.php/s/wBx9BjKLagnXpfk/preview width=420 height=315 />

The Application consists of 3 classes which includes
 - UserInterface : This class is used for determining the Tkinter settings and combine the TKObject class and Graph class 
                 to access the objects and insert the objects into the User Interface.
 - TKObject : This class creates the OptionMenu and Label from the Tkinter library with the specified x and y coordinates 
            to be placed in the interface. The objects will also update the graph after the user selects the menu in the 
            OptionMenu.
 - Graph : The 5 graph will be created in the Graph class with the decoration and the specified x and y coordinates.
According to the 2 Graph appearances, the UserInterface creates the Graph for an initializing purpose while the 
TKObject updates the Graph that depends on the users' dropdown interaction.
 
## Design Patterns Used
This project includes the Facade pattern. The objects in the TKObject class and the Graph class
will be inserted into the interface beneath the declaration of the UserInterface class commands.
## Interesting Facts
- Group, as one of the attributes in the astronaut.csv, means an ordinal number of the NASA selection as crew members 
  or astronauts for preparing to have the space missions. Surprisingly, more than half of the selected astronauts 
  came from the military service.
- eval() in the Graph.py file is a handy method to convert string into a code object. In the file case, the eval()
  method turned the string into the function as ax.set_xticks() and ax.set_yticks() immediately.
- The reason why _param is added to the function in UserInterface.py because the function, that is linked to the 
  ComboBox "command" parameter, requires 1 parameter. So, the parameter has been set to _param=None instead for
  answering that the function doesn't need the parameter. If the _param=None is not filled, the Exception in
  Tkinter callback will occur.



