import tkinter as tk
import pandas as pd
from TKObject import TKObject
from Graph import Graph


class UserInterface(tk.Tk):

    def __init__(self):
        super().__init__()
        self.title("NASA")
        self.geometry("1000x800")
        self.resizable(False, False)
        self.configure(bg="#0b3d91")
        self.object = TKObject(self, pd.read_csv('astronauts.csv').sort_values(by='name'))
        self.graph = Graph(self, pd.read_csv('astronauts.csv').sort_values(by='name'))

    def display(self) -> None:
        self.object.add_text()
        self.object.create_dropdown()
        self.object.update_text()
        self.graph.histogram('group')
        self.graph.heatmap()
        self.graph.piechart('gender')
